=== debian/changelog ===
wasi-libc (0.0~git20220510.9886d3d-2) unstable; urgency=medium

  * d/copyright: add missing license info
  * bump Standards-Version to 4.6.1
  * bump debhelper compat to 13

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Wed, 07 Dec 2022 19:57:26 +0100

wasi-libc (0.0~git20220510.9886d3d-1) unstable; urgency=medium

  * Upload to unstable.

 -- Fabian Gruenbichler <debian@fabian.gruenbichler.email>  Wed, 07 Dec 2022 17:37:58 +0100

wasi-libc (0.0~git20220510.9886d3d-1~exp1) experimental; urgency=medium

  * New upstream release
  * Update to LLVM 14, same as rustc (Closes: #1017661)

 -- Fabian Grünbichler <f.gruenbichler@proxmox.com>  Thu, 29 Sep 2022 12:11:17 +0200
