=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
-Uploaders: Ximin Luo <infinity0@debian.org>
-Build-Depends: debhelper-compat (= 13), clang-14, llvm-14
-Standards-Version: 4.6.1
+Uploaders:
+ Ximin Luo <infinity0@debian.org>,
+ Fabian Grünbichler <debian@fabian.gruenbichler.email>
+Build-Depends: debhelper-compat (= 13), clang-16, llvm-16
+Standards-Version: 4.6.2
 Homepage: https://github.com/CraneStation/wasi-libc
 Vcs-Browser: https://salsa.debian.org/rust-team/wasi-libc
 Vcs-Git: https://salsa.debian.org/rust-team/wasi-libc.git
