=== debian/rules ===
--- 
+++ 
@@ -5,13 +5,14 @@
 
 include /usr/share/dpkg/buildflags.mk
 
-export NM = llvm-nm-14
-export AR = llvm-ar-14
-export CC = clang-14
+export NM = llvm-nm-16
+export AR = llvm-ar-16
+export CC = clang-16
 
 # stack protector not yet supported, see
 # https://github.com/CraneStation/wasi-libc/issues/157
-export EXTRA_CFLAGS = $(CFLAGS) $(LDFLAGS) -fno-stack-protector
+# https://bugs.debian.org/1051815
+export EXTRA_CFLAGS = $(CFLAGS) $(LDFLAGS) -fno-stack-protector -fcf-protection=none
 
 %:
 	dh $@
