## wasi-libc 0.0~git20230821.ec4566b

=== debian/changelog ===
wasi-libc (0.0~git20230821.ec4566b-2) unstable; urgency=medium

  * upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 28 May 2024 17:07:51 +0200

wasi-libc (0.0~git20230821.ec4566b-1) experimental; urgency=medium

  * new upstream version needed for rustc 1.73+
  * switch to LLVM 17

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Tue, 28 May 2024 17:07:42 +0200

wasi-libc (0.0~git20230621.7018e24-2) unstable; urgency=medium

  * upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Mon, 27 May 2024 14:48:31 +0200

wasi-libc (0.0~git20230621.7018e24-1) experimental; urgency=medium

  * new upstream version needed for rustc 1.72.1+

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Fri, 24 May 2024 10:30:30 +0200
