## wasi-libc 0.0~git20240411.9e8c542

=== debian/changelog ===
wasi-libc (0.0~git20240411.9e8c542-3) unstable; urgency=medium

  * enable "p2" variant, and symlink old one under the new "p1" name

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 31 Jul 2024 09:21:15 +0200

wasi-libc (0.0~git20240411.9e8c542-2) unstable; urgency=medium

  * upload to unstable

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 26 Jun 2024 08:47:27 +0200

wasi-libc (0.0~git20240411.9e8c542-1) experimental; urgency=medium

  * new upstream version needed for rustc 1.79+ (WASI SDK 22)

 -- Fabian Grünbichler <debian@fabian.gruenbichler.email>  Wed, 26 Jun 2024 08:47:04 +0200
