=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,9 @@
 
 include /usr/share/dpkg/buildflags.mk
 
-export NM = llvm-nm-16
-export AR = llvm-ar-16
-export CC = clang-16
+export NM = llvm-nm-17
+export AR = llvm-ar-17
+export CC = clang-17
 
 # stack protector not yet supported, see
 # https://github.com/CraneStation/wasi-libc/issues/157
@@ -23,6 +23,8 @@
 
 override_dh_auto_build:
 	dh_auto_build -- finish
+	dh_auto_build -- WASI_SNAPSHOT=p2 finish
 
 override_dh_auto_install:
 	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr
+	dh_auto_install -- INSTALL_DIR=$(CURDIR)/debian/tmp/usr WASI_SNAPSHOT=p2
