## wasi-libc 0.0~git20240708.3f43ea9

=== Makefile ===
--- 
+++ 
@@ -15,12 +15,23 @@
 INSTALL_DIR ?= /usr/local
 # single or posix; note that pthread support is still a work-in-progress.
 THREAD_MODEL ?= single
+# p1 or p2; the latter is not (yet) compatible with multithreading
+WASI_SNAPSHOT ?= p1
 # dlmalloc or none
 MALLOC_IMPL ?= dlmalloc
 # yes or no
 BUILD_LIBC_TOP_HALF ?= yes
+# yes or no
+BUILD_LIBSETJMP ?= yes
 # The directory where we will store intermediate artifacts.
-OBJDIR ?= $(CURDIR)/build/$(TARGET_TRIPLE)
+OBJDIR ?= build/$(TARGET_TRIPLE)
+# The directory where we store files and tools for generating WASIp2 bindings
+BINDING_WORK_DIR ?= build/bindings
+# URL from which to retrieve the WIT files used to generate the WASIp2 bindings
+WASI_CLI_URL ?= https://github.com/WebAssembly/wasi-cli/archive/refs/tags/v0.2.0.tar.gz
+# URL from which to retrieve the `wit-bindgen` command used to generate the
+# WASIp2 bindings.
+WIT_BINDGEN_URL ?= https://github.com/bytecodealliance/wit-bindgen/releases/download/wit-bindgen-cli-0.17.0/wit-bindgen-v0.17.0-x86_64-linux.tar.gz
 
 # When the length is no larger than this threshold, we consider the
 # overhead of bulk memory opcodes to outweigh the performance benefit,
@@ -35,21 +46,27 @@
 # Set the default WASI target triple.
 TARGET_TRIPLE = wasm32-wasi
 
-# Threaded version necessitates a different traget, as objects from different
+# Threaded version necessitates a different target, as objects from different
 # targets can't be mixed together while linking.
 ifeq ($(THREAD_MODEL), posix)
 TARGET_TRIPLE = wasm32-wasi-threads
 endif
 
+ifeq ($(WASI_SNAPSHOT), p2)
+TARGET_TRIPLE = wasm32-wasip2
+endif
+
+BUILTINS_LIB ?= $(shell ${CC} --print-libgcc-file-name)
+
 # These variables describe the locations of various files and directories in
 # the source tree.
-DLMALLOC_DIR = $(CURDIR)/dlmalloc
+DLMALLOC_DIR = dlmalloc
 DLMALLOC_SRC_DIR = $(DLMALLOC_DIR)/src
 DLMALLOC_SOURCES = $(DLMALLOC_SRC_DIR)/dlmalloc.c
 DLMALLOC_INC = $(DLMALLOC_DIR)/include
-EMMALLOC_DIR = $(CURDIR)/emmalloc
+EMMALLOC_DIR = emmalloc
 EMMALLOC_SOURCES = $(EMMALLOC_DIR)/emmalloc.c
-LIBC_BOTTOM_HALF_DIR = $(CURDIR)/libc-bottom-half
+LIBC_BOTTOM_HALF_DIR = libc-bottom-half
 LIBC_BOTTOM_HALF_CLOUDLIBC_SRC = $(LIBC_BOTTOM_HALF_DIR)/cloudlibc/src
 LIBC_BOTTOM_HALF_CLOUDLIBC_SRC_INC = $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/include
 LIBC_BOTTOM_HALF_HEADERS_PUBLIC = $(LIBC_BOTTOM_HALF_DIR)/headers/public
@@ -59,6 +76,43 @@
     $(sort \
     $(shell find $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC) -name \*.c) \
     $(shell find $(LIBC_BOTTOM_HALF_SOURCES) -name \*.c))
+
+ifeq ($(WASI_SNAPSHOT), p1)
+# Omit source files not relevant to WASIp1.  As we introduce files
+# supporting `wasi-sockets` for `wasm32-wasip2`, we'll add those files to
+# this list.
+LIBC_BOTTOM_HALF_OMIT_SOURCES := \
+	$(LIBC_BOTTOM_HALF_SOURCES)/wasip2.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/descriptor_table.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/connect.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/socket.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/send.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/recv.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/sockets_utils.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/bind.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/listen.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/accept-wasip2.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/shutdown.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/sockopt.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/poll-wasip2.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/getsockpeername.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/netdb.c
+LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_OMIT_SOURCES),$(LIBC_BOTTOM_HALF_ALL_SOURCES))
+# Omit p2-specific headers from include-all.c test.
+# for exception-handling.
+INCLUDE_ALL_CLAUSES := -not -name wasip2.h -not -name descriptor_table.h
+endif
+
+ifeq ($(WASI_SNAPSHOT), p2)
+# Omit source files not relevant to WASIp2.
+LIBC_BOTTOM_HALF_OMIT_SOURCES := \
+	$(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/libc/sys/socket/send.c \
+	$(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/libc/sys/socket/recv.c \
+	$(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/libc/sys/socket/shutdown.c \
+	$(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/libc/sys/socket/getsockopt.c \
+	$(LIBC_BOTTOM_HALF_SOURCES)/accept-wasip1.c
+LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_OMIT_SOURCES),$(LIBC_BOTTOM_HALF_ALL_SOURCES))
+endif
 
 # FIXME(https://reviews.llvm.org/D85567) - due to a bug in LLD the weak
 # references to a function defined in `chdir.c` only work if `chdir.c` is at the
@@ -78,8 +132,10 @@
 LIBWASI_EMULATED_SIGNAL_MUSL_SOURCES = \
     $(LIBC_TOP_HALF_MUSL_SRC_DIR)/signal/psignal.c \
     $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/strsignal.c
+LIBDL_SOURCES = $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/dl.c
+LIBSETJMP_SOURCES = $(LIBC_TOP_HALF_MUSL_SRC_DIR)/setjmp/wasm32/rt.c
 LIBC_BOTTOM_HALF_CRT_SOURCES = $(wildcard $(LIBC_BOTTOM_HALF_DIR)/crt/*.c)
-LIBC_TOP_HALF_DIR = $(CURDIR)/libc-top-half
+LIBC_TOP_HALF_DIR = libc-top-half
 LIBC_TOP_HALF_MUSL_DIR = $(LIBC_TOP_HALF_DIR)/musl
 LIBC_TOP_HALF_MUSL_SRC_DIR = $(LIBC_TOP_HALF_MUSL_DIR)/src
 LIBC_TOP_HALF_MUSL_INC = $(LIBC_TOP_HALF_MUSL_DIR)/include
@@ -97,6 +153,7 @@
         misc/getopt.c \
         misc/getopt_long.c \
         misc/getsubopt.c \
+        misc/realpath.c \
         misc/uname.c \
         misc/nftw.c \
         errno/strerror.c \
@@ -194,6 +251,13 @@
                  $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/complex/*.c)) \
     $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/crypt/*.c)
 
+ifeq ($(WASI_SNAPSHOT), p2)
+LIBC_TOP_HALF_MUSL_SOURCES += \
+    $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
+       network/gai_strerror.c \
+    )
+endif
+
 ifeq ($(THREAD_MODEL), posix)
 LIBC_TOP_HALF_MUSL_SOURCES += \
     $(addprefix $(LIBC_TOP_HALF_MUSL_SRC_DIR)/, \
@@ -229,79 +293,10 @@
         thread/pthread_create.c \
         thread/pthread_detach.c \
         thread/pthread_equal.c \
+        thread/pthread_getattr_np.c \
         thread/pthread_getspecific.c \
         thread/pthread_join.c \
         thread/pthread_key_create.c \
         thread/pthread_mutex_consistent.c \
         thread/pthread_mutex_destroy.c \
         thread/pthread_mutex_init.c \
-        thread/pthread_mutex_getprioceiling.c \
-        thread/pthread_mutex_lock.c \
-        thread/pthread_mutex_timedlock.c \
-        thread/pthread_mutex_trylock.c \
-        thread/pthread_mutex_unlock.c \
-        thread/pthread_mutexattr_destroy.c \
-        thread/pthread_mutexattr_init.c \
-        thread/pthread_mutexattr_setprotocol.c \
-        thread/pthread_mutexattr_setpshared.c \
-        thread/pthread_mutexattr_setrobust.c \
-        thread/pthread_mutexattr_settype.c \
-        thread/pthread_once.c \
-        thread/pthread_rwlock_destroy.c \
-        thread/pthread_rwlock_init.c \
-        thread/pthread_rwlock_rdlock.c \
-        thread/pthread_rwlock_timedrdlock.c \
-        thread/pthread_rwlock_timedwrlock.c \
-        thread/pthread_rwlock_tryrdlock.c \
-        thread/pthread_rwlock_trywrlock.c \
-        thread/pthread_rwlock_unlock.c \
-        thread/pthread_rwlock_wrlock.c \
-        thread/pthread_rwlockattr_destroy.c \
-        thread/pthread_rwlockattr_init.c \
-        thread/pthread_rwlockattr_setpshared.c \
-        thread/pthread_setcancelstate.c \
-        thread/pthread_setspecific.c \
-        thread/pthread_self.c \
-        thread/pthread_testcancel.c \
-        thread/sem_destroy.c \
-        thread/sem_getvalue.c \
-        thread/sem_init.c \
-        thread/sem_post.c \
-        thread/sem_timedwait.c \
-        thread/sem_trywait.c \
-        thread/sem_wait.c \
-        thread/wasm32/wasi_thread_start.s \
-    )
-endif
-
-MUSL_PRINTSCAN_SOURCES = \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/floatscan.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfprintf.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfwprintf.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfscanf.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/strtod.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/wcstod.c
-BULK_MEMORY_SOURCES = \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memcpy.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memmove.c \
-    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/memset.c
-LIBC_TOP_HALF_HEADERS_PRIVATE = $(LIBC_TOP_HALF_DIR)/headers/private
-LIBC_TOP_HALF_SOURCES = $(LIBC_TOP_HALF_DIR)/sources
-LIBC_TOP_HALF_ALL_SOURCES = \
-    $(LIBC_TOP_HALF_MUSL_SOURCES) \
-    $(sort $(shell find $(LIBC_TOP_HALF_SOURCES) -name \*.[cs]))
-
-# Add any extra flags
-CFLAGS = $(EXTRA_CFLAGS)
-# Set the target.
-CFLAGS += --target=$(TARGET_TRIPLE)
-ASMFLAGS += --target=$(TARGET_TRIPLE)
-# WebAssembly floating-point match doesn't trap.
-# TODO: Add -fno-signaling-nans when the compiler supports it.
-CFLAGS += -fno-trapping-math
-# Add all warnings, but disable a few which occur in third-party code.
-CFLAGS += -Wall -Wextra -Werror \
-  -Wno-null-pointer-arithmetic \
-  -Wno-unused-parameter \
-  -Wno-sign-compare \
-  -Wno-unused-variable \
